#Compile Exe  "fnPtrs1"                     'Shows how to use function pointers
#Dim All                                    'and PowerBASIC's powerful
                                            'Call Dword statement to execute a
Declare Function ptrFn(x As Long) As Long   'function at a given address.

Function x_Squared(n As Long) As Long       'Returns a long and takes a long
  x_Squared = n * n                         'as a parameter.
End Function

Function x_Cubed(n As Long) As Long         'Returns a long and takes a long
  x_Cubed = n * n * n                       'as a parameter
End Function

Function x_ToTheFourth(n As Long) As Long   'Returns a long and takes a long
  x_ToTheFourth = n * n * n * n             'as a parameter
End Function

Function x_ToTheFifth(n As Long) As Long    'Returns a long and takes a long
  x_ToTheFifth = n * n * n * n * n          'as a parameter
End Function

Function PBMain() As Long        'What matters with function pointers isn't
  Local pFns() As Dword          'what the function does so much as its address,
  Local iResult As Long          'its parameters, and its return value.
  Register i As Long

  Redim pFns(3) As Dword
  pFns(0)=CodePtr(x_Squared)     'pFns(0) will hold integer address of x_Squared
  pFns(1)=CodePtr(x_Cubed)       'pFns(1) will hold address of x_Cubed
  pFns(2)=CodePtr(x_ToTheFourth) 'pFns(2) -------------------- x_ToTheFourth
  pFns(3)=CodePtr(x_ToTheFifth)  'pFns(3) -------------------- x_ToTheFifth
  Print " i             pFns(i)       iResult"
  Print "===================================="
  For i=0 To 3                                     'Send program execution to
    Call Dword pFns(i) Using ptrFn(i) To iResult   'addresses stored in array
    Print i, pFns(i), iResult                      'of function pointers.  Use
  Next i                                           'a 'model' function ptrFn()
  Erase pFns                                       'that has the same function
  Waitkey$                                         'signature as the four fns
                                                   'to be called.  Return the
  PBMain=0                                         'result of the function call
End Function                                       'TO iResult.

'Output:
'
' i             pFns(i)       iResult
'====================================
' 0             4200232       0
' 1             4200298       1
' 2             4200369       16
' 3             4200445       243
