#Compile Exe  "Label4.exe"    'Label4.bas  Now we're actually managing to get the
#Include "Win32api.inc"       'the caption of the labels from the CREATESTRUCT
%IDC_LABEL1 = 1201            'passed in the WM_CREATE message.  However, all
%IDC_LABEL2 = 1203            'is not well.  The same caption shows up on both
                              'labels!

Function fnLabelWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static szCaption As Asciiz*32

  Select Case As Long wMsg
    Case %WM_CREATE
      Local lpCreateStruct As CREATESTRUCT Ptr
      lpCreateStruct=lParam
      szCaption=@lpCreateStruct.@lpszName
      fnLabelWndProc=0
      Exit Function
    Case %WM_PAINT
      Local lpPaint As PAINTSTRUCT
      Local hDC As Long
      hDC=BeginPaint(hWnd,lpPaint)
      Call SetBkMode(hDC,%TRANSPARENT)
      Call TextOut(hDC,0,0,szCaption,Len(szCaption))
      Call EndPaint(hWnd,lpPaint)
      fnLabelWndProc=0
      Exit Function
  End Select

  fnLabelWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function

Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CREATE
      Local hInst As Dword
      Local lpCreateStruct As CREATESTRUCT Ptr
      Local szClassName As Asciiz*16
      Local wc As WndClassEx
      Local hLabel1 As Dword, hLabel2 As Dword
      lpCreateStruct=lParam
      hInst=@lpCreateStruct.hInstance
      szClassName="MyLabel"
      wc.lpfnWndProc=CodePtr(fnLabelWndProc)
      wc.lpszClassName=VarPtr(szClassName)
      wc.style=%CS_HREDRAW Or %CS_VREDRAW
      wc.cbClsExtra=0
      wc.cbWndExtra=0
      wc.hInstance=hInst
      wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
      wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
      wc.hbrBackground=%COLOR_BTNFACE+1
      wc.lpszMenuName=%NULL
      wc.cbSize=SizeOf(wc)
      Call RegisterClassEx(wc)

      hLabel1= _                      'Try To Make 1st Label
      CreateWindowEx _
      ( _
        0, _                          'No Extended Styles
        "MyLabel", _                  'Class Name We Conjured Up
        "Label1", _                   'Caption or Window Text To Be In Label
        %WS_CHILD Or %WS_VISIBLE, _   'Lets add %WS_BORDER to see if this is working
        20,10,50,20, _                'Where the label should show up on the Form
        hWnd, _                       'Parent is main window
        %IDC_LABEL1, _                'Control ID for label (see equates)
        hInst, _                      'We got this from Window Creation CREATESTRUCT
        ByVal 0 _                     'We're not passing any special window creation data
      )

      hLabel2= _                      'Try To Make 2nd Label
      CreateWindowEx _
      ( _
        0, _                          'No Extended Styles
        "MyLabel", _                  'Class Name We Conjured Up
        "Label2", _                   'Caption or Window Text To Be In Label
        %WS_CHILD Or %WS_VISIBLE, _   'Lets add %WS_BORDER to see if this is working
        20,45,50,20, _                'Where the label should show up on the Form
        hWnd, _                       'Parent is main window
        %IDC_LABEL2, _                'Control ID for label (see equates)
        hInst, _                      'We got this from Window Creation CREATESTRUCT
        ByVal 0 _                     'We're not passing any special window creation data
      )
      fnWndProc=0
      Exit Function
    Case %WM_DESTROY
      PostQuitMessage 0
      fnWndProc=0
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function

Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local winclass As WndClassEx
  Local szAppName As Asciiz*16
  Local Msg As tagMsg
  Local hWnd As Dword

  szAppName="Label4"
  winclass.cbSize=SizeOf(winclass)
  winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.lpfnWndProc=CodePtr(fnWndProc)
  winclass.cbClsExtra=0
  winclass.cbWndExtra=0
  winclass.hInstance=hIns
  winclass.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  winclass.hbrBackground=%COLOR_BTNFACE+1
  winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)
  Call RegisterClassEx(winclass)
  hWnd=CreateWindowEx(0,szAppName,"Label4",%WS_OVERLAPPEDWINDOW,200,100,325,300,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
